﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace AdaptableStateMachine.BoringStateMachine
{
    class BoringMachine : IStateMachine
    {
        BoringMachineState mState = new BoringMachineState();

        public override IState CurrentState
        {
            get { return mState; }
        }
        public override string[] PossibleTransitions()
        {
            // For this simple example, forward it on to the state
            return mState.ListTransitions();
        }
        public override bool Advance(string nextState)
        {
            Console.WriteLine("I'm a boring state machine.  I don't care what you entered.  Advancing state.");
            return mState.Advance();
        }
        public override bool IsComplete()
        {
            // For the simple example, forward it on to the state
            return mState.IsComplete();
        }
    }
}
