﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace AdaptableStateMachine.BoringStateMachine
{
    class BoringMachineState : IState
    {
        #region Members
        internal enum SameOldStates
        {
            Enter,
            DoStuff,
            Exiting,
            Done
        }
        SameOldStates mState = SameOldStates.Enter;
        #endregion
        #region IState overrides
        public override string GetName()
        {
            return mState.ToString();
        }
        public override void Run()
        {
            // Do nothing.
        }
        #endregion
        #region Helper functions
        public bool IsComplete()
        {
            return mState == SameOldStates.Done;
        }
        public string[] ListTransitions()
        {
            List<string> result = new List<string>();
            switch (mState)
            {
                case SameOldStates.Enter:
                    result.Add("DoStuff");
                    break;
                case SameOldStates.DoStuff:
                    result.Add("Exiting");
                    break;
                case SameOldStates.Exiting:
                    result.Add("Done");
                    break;
                case SameOldStates.Done:
                    result.Add("Done");
                    break;
            }
            return result.ToArray();
        }
        public bool Advance()
        {
            switch (mState)
            {
                case SameOldStates.Enter:
                    mState = SameOldStates.DoStuff;
                    break;
                case SameOldStates.DoStuff:
                    mState = SameOldStates.Exiting;
                    break;
                case SameOldStates.Exiting:
                    mState = SameOldStates.Done;
                    break;
                case SameOldStates.Done:
                    // Do nothing.
                    break;
            }
            return true;
        }
        #endregion
    }
}
