﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;

namespace FSM_Puppies.Game.Activities
{
    class ChaseBall : Activity
    {
        RunToObject mRto;

        /// <summary>
        /// Initializes a new instance of the ChaseBall class.
        /// </summary>
        public ChaseBall(GameObject actor, GameObject target)
            : base(actor, target)
        {
            mRto = new RunToObject(actor, target);
        }

        public override bool Update(float seconds)
        {
            // Did they kick the ball yet?
            if( mRto.Update(seconds) == true)
            {
                float kickDistance = FSM_Puppies.Properties.Settings.Default.Activity_ChaseBall_KickDistance;
                // Get a random number with +/- kick distance
                float newX = Target.Location.X + (((float)Target.Owner.Rng.NextDouble()*(2*kickDistance))-kickDistance);
                float newY = Target.Location.Y + (((float)Target.Owner.Rng.NextDouble()*(2*kickDistance))-kickDistance);
                PointF randomLocation = new PointF(newX,newY);
                Target.Location = randomLocation;
                return true;
            }
            return false;
        }
    }
}
