﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;

namespace FSM_Puppies.Game.Activities
{
    class RunToObject : Activity
    {
        /// <summary>
        /// Initializes a new instance of the RunToObject class.
        /// </summary>
        public RunToObject(GameObject actor, GameObject target)
            : base(actor, target)
        {
            
        }
        public override bool Update(float seconds)
        {
            // Are we there yet?
            // And why didn't they implement operator- ?
            PointF offset = new PointF( Target.Location.X - Actor.Location.X, Target.Location.Y - Actor.Location.Y);
            float distanceSquared = offset.X * offset.X + offset.Y * offset.Y;
            float closeEnough = FSM_Puppies.Properties.Settings.Default.Activity_RunToObject_CloseEnough;
            float closeEnoughSquared = closeEnough * closeEnough;
            if (distanceSquared < closeEnoughSquared)
                return true;

            Actor.PushToward(Target.Location, seconds);
            return false;
        }
    }
}
