﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Text;

namespace FSM_Puppies.Game.Pets
{
    class Puppy : Pet
    {

        MotiveBase mMotives = new MotiveBase();


        /// <summary>
        /// Initializes a new instance of the GameObject class.
        /// </summary>
        public Puppy(PlayingField owner)
            : base(owner)
        {
            
        }

        public override void Update(float seconds)
        {
            if(Activity == null)
            {
                Activity = new Activities.Idle(this, null);
            }
            Activity.Update(seconds);
        }

        public override System.Drawing.Image Image
        {
            get { return FSM_Puppies.Properties.Resources.Puppy; }
        }

        public override void PushToward(System.Drawing.PointF destination, float seconds)
        {
            // For now don't accumulate.  Just push it the correct direction.
            // Create a vector class someday
            float xDiff = destination.X - Location.X;
            float yDiff = destination.Y - Location.Y;
            float magnitude = (float)Math.Sqrt(xDiff * xDiff) + (float)Math.Sqrt(yDiff * yDiff);
            if (magnitude > (MaxSpeed() * seconds))
            {
                float scale = (MaxSpeed() * seconds) / magnitude;
                xDiff *= scale;
                yDiff *= scale;
            }
            Location = new PointF(xDiff + Location.X, yDiff + Location.Y);
        }

        public override float MaxSpeed()
        {
            return FSM_Puppies.Properties.Settings.Default.Pet_Puppy_MaxSpeed;   
        }
    }
}
